/*****************************************************************
 * PONCON.C
 * Version 1.0.1
 * By Val Laughlin
 * Last modified:  5 Nov 94
 * Compiler: Mix PowerC, version 2.0.1
 *
 * This program converts files used in P.J. Ponzo's excellent
 * C tutorial program to standard ASCII text files.
 *****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <errno.h>
#include <dos.h>
#include <bios.h>

int main(int argc, char *argv[])
{
  char s[100];
  int ch;
  int i, asterisk;
  long count1;
  int count2, intpercent;
  float fcount1, fcount2, percentage;

  FILE *fp, *file, *foutp;

  clrscrn();
  printf("Ponzo Convert\n");
  printf(" Version 1.0.1 \n");
  printf(" Nov 5, 1994 \n");
  printf(" by Val Laughlin \n");
  printf(" - Converts files from P.J. Ponzo's C tutorial\n");
  printf(" - to standard ASCII text files.\n\n");

/* Check the command line arguments */
  if (argc != 3)
  {
    printf("\nFormat:  FOO infile outfile\n");
    return 1;
  }
/* Count the lines in the file */
  if ((fp = fopen(argv[1], "r")) == NULL)
  {
    printf("\nCan't open input file\n");
    return 1;
  }
  count1 = 0;
  while ((ch = fgetc(fp)) != EOF)
  {
    if (ch == '\n')
      count1++;
  }
  fcount1 = count1;
  fclose(fp);

/* First, remove DOT command lines, writing to a temporary file */
  poscurs(8,0);
  printf("Clearing DOT command lines...");
  if ( ( fp = fopen( argv[1], "r" ) ) == NULL )
  {
	printf("\n Input file open error \n" );
	printf(" Check to see that you are in the right directory...\n");
	return 1;
  }
  if ( ( foutp = fopen( "outfile.tmp", "w" ) ) == NULL )
  {
	fclose( fp );
	printf( " -=- Output file open error -=-" );
	return 1;
  }
  count2 = 0;
  poscurs (10, 0);
  printf("     1    2    3    4    5    6    7    8    9     \n");
  printf(" ____0____0____0____0____0____0____0____0____0_____\n");
  printf("[                                                  ]");
  poscurs(12, 1);
  for (i=0; i<50; i++)
    printf("o");
  i=1;
  poscurs(12,i);

  while ( ( fgets( s, 100, fp ) ) != NULL )
  {
    count2++;
    fcount2 = count2;
	percentage = (((fcount1-(fcount1-fcount2))/fcount1)*100);
	intpercent = percentage;
    poscurs(9,1);
    printf("%4.2f percent ", percentage);

	if ((intpercent > 0) && !(intpercent % 2))
	{
	  if (!asterisk)
	  {
	    poscurs(12, i++);
	    printf("%c", 178);
        asterisk = 1;
	  }
	}
	else
	  (asterisk = 0);
	if (s[0] != '.')
	  fputs( s, foutp );
  }
  fclose( foutp );
  fclose( fp );


/* Now, proceed with clearing the ~ commands. */
  poscurs(8,0);
  printf("Now clearing ~ commands...              ");
  if ((fp = fopen("outfile.tmp", "r")) == NULL)
  {
	printf("\nCan't open temporary file (OUTFILE.TMP)\n");
	return 1;
  }
  if ((foutp = fopen( argv[2], "w")) == NULL)
  {
	fclose(fp);
	printf( " Output file open error ");
	return 1;
  }

  count2 = 0;
  poscurs (10, 0);
  printf("     1    2    3    4    5    6    7    8    9     \n");
  printf(" ____0____0____0____0____0____0____0____0____0_____\n");
  printf("[                                                  ]");
  poscurs(12, 1);
  for (i=0; i<50; i++)
    printf("o");
  i = 1;
  poscurs(12,i);

  for (count1 = 0; (ch = fgetc(fp)) != EOF; count1++)

  fcount1 = count1;

  rewind(fp);
  while ( (ch = fgetc(fp) ) != EOF)
	{
	  count2++;
	  if (ch == '')
	  {
	    do
	    {
	      ch = fgetc(fp);
	    }
	    while (ch != 'm');
	  }
	  else if (ch == '~')
	  {
	    fgetc(fp);
	    count2++;
	  }
	  else
	  {
	    fputc(ch, foutp);
	  }
	  fcount2 = count2;
      percentage = (((fcount1-(fcount1-fcount2))/fcount1)*100);
	  intpercent = percentage;
      poscurs(9,1);
      printf("%4.2f percent ", percentage);

	  if (!(intpercent % 2))
	  {
	    if (!asterisk)
	    {
	      poscurs(12, i++);
	      printf("%c", 178);
          asterisk = 1;
	    }
      }
      else
	asterisk = 0;
    }

	if (intpercent < 100)
	{
	  poscurs(12,i);
	  printf("%c", 178);
	}

	fclose(foutp);
	fclose(fp);
	if( remove( "outfile.tmp" ) == -1 )
      perror( "Could not delete 'OUTFILE.TMP'.\n...Recommend you delete it manually.\n" );

	/* Get an ad in! */
	poscurs(15,0);
	printf("Complete...\n");
	printf("-=*=- Call The Night C/I/E BBS at 318-752-2237 -=*=-\n\n");
	return 0;
}

